	PAGE,132
;THIS ROUTINE PLOTS DATA FOUND IN ARRAY NAME%.
;SIX OTHER INTEGER VARIABLES ARE PASSED WHEN ROUTINE IS CALLED.
;THESE VARIABLES TELL THE ROUTINE WETHER TO PLOT LINES OR DOTS,
;WETHER TO INVERT  THE ARRAY, WETHER THERE ARE ANY OFFSETS TO ADD
;TO THE DATA BEFORE PLOTTING, AND WHERE TO PUT THE CURSORS.
;
;THE FORM OF THE CALL IS
;
;  CALL PLOT!(NAME(0), LYNE, INVERT, VOFFSET, HOFFSET,X1,X2)
;
;          WHERE...PLOT!        =ADDRESS OF ROUTINE RELATIVE TO CURRENT DEF SEG
;		   NAME(0)     = FIRST ARRAY ADDRESS
;	  	   LYNE      =1...LINE    =0...DOT  INTEGER
;		   INVERT    =1...INVERT  =0...NORMAL  INTEGER
;		   OFFSET =SIGNED TWO'S COMPLIMENT OFFSET  INTEGER  
;		   X1 =X COORDINATE OF CURSOR 1
;		   X2 =X COORDINATE OF CURSOR 2
;			NO CURSOR WILL BE PLOTTED IF X<0 OR X>500
;
;		
;		LYNE     WILL BE STORED IN AL BIT 1
;		INVERT   WILL BE STORED IN AL BIT 0
;		VOFFSET  WILL BE STORED IN DX
;		IF PLOT IS OFFSCREEN, AL BIT 2 WILL BE 0
;
;
PLOT	SEGMENT
	ASSUME	CS:PLOT
MAP	EQU	47050D		;MEMORY  CLEARED BY BASIC 
					;
START	PROC	FAR
	PUSH	BP				;SAVE BP
	MOV	BP,SP			;POINTER TO TOP OF STACK
	INC	BP
	INC	BP
	MOV	SI,16[BP]		;FIRST VARIBLE  [ARRAY ADDRESS]
					;DS:[SI] POINTS TO BEGINNING OF ARRAY
;
	MOV	AL,00H			;PRESET TO DOT AND NORMAL
;
	MOV	DI,14[BP]		;2ND VARIABLE  [LINE/DOT]
	MOV	BX,WORD PTR [DI]
	CMP	BX,00H			;COMPARE TO DOT COMMAND
	JE	DOT
LINE_:	MOV	AL,02H			;ELSE SET LINE BIT
DOT:	
	MOV	DI,12[BP]		;3RD VARIABLE  [INVERT/NORMAL]
	MOV	BX,WORD PTR [DI]	
	CMP	BX,00H			;COMPARE TO NORMAL
	JE	NORMAL
	OR	AL,01H			;SET INVERT BIT
NORMAL:
;
	MOV	DI,10[BP]		;4TH VARIABLE  [VOFFSET]
	MOV	DX,WORD PTR [DI]	;DX CONTAINS VOFFSET
;
	MOV	DI,8[BP]			;5TH VARIABLE [HOFFSET]
	MOV	CX,WORD PTR [DI]	;CX CONTAINS HOFFSET 
	PUSH ES				;SP=SP-2
	MOV	BX,DS			;PUT DS: IN ES: TO ACCESS DATA
	MOV	ES,BX
	PUSH DS				;SP=SP-2
	MOV	BX,0B800H			;USE DS: TO POINT TO VIDEO
	MOV	DS,BX
	MOV	DI,SI			;CALCULATE LAST POINT TO PLOT
	ADD	DI,1000
	PUSH	DI				;STORE LASTPOINT ON STACK
;
LOOP:
	MOV	BX,DX			;GET VOFFSET
	ADD	BX,WORD PTR ES:[SI]	;SHOULD ADD FIRST POINT OF ARRAY
                                      	;VALUE IS BETWEEN 0 AND 255
	TEST	AL,01			;CHECK FOR INVERT
	JZ	PLUS
	NEG	BX				;NORMAL
	ADD	BX,256			;BX=256-BX
;
PLUS:
	SHL	BX,1				;BX HAS 2 * Y COORDINATE, 
						;CX HAS X COORDINATE
;
LINELOOP:
	CALL	PRINT1			;BP HAS HORIZONTAL BYTE COUNT
						;AH HAS CURRENT OUTPUT BYTE
	POP	DI
	CMP	SI,DI			;DONE?
	JE	PLOTDONE
	PUSH	DI				;NOT DONE..PUT ENDPOINT BACK
	INC	SI				;GET READY FOR NEXT POINT
	INC	SI
	INC	CX
;
	TEST	AL,02			;IS LINE ON?
	JZ	LOOP				;IF NOT, GO DO NEXT POINT
;
						;LINE IS ON
	PUSH	CX				;DON'T NEED THIS FOR AWHILE
	MOV	CX,DX			;GET VOFFSET
	ADD	CX,ES:[SI]		;GET NEXT POINT TO PLOT
	TEST	AL,01			;CHECK FOR INVERT
	JZ	PLUS1
	NEG	CX
	ADD	CX,256
PLUS1:					;CX HAS 2 * NEXT POINT
	SHL	CX,1				;BX HAS 2 * POINT JUST PLOTTED
						;BP AND AH ARE SET UP
;
	CMP	BP,62			;MAKE SURE BP IS ON SCREEN
	JG	LINEDONE			;IF NOT,DON'T WASTE TIME
	OR	BP,BP
	JS	LINEDONE
;
LINE:
	CMP	BX,CX
	JE	LINEDONE			;STOP IF LAST POINT =NEW POINT
	JL	UP
DOWN:
	SUB	BX,2
	CMP	BX,CX			;SEE IF DONE
	JE	LINEDONE
;
	CMP	BX,56			;MAKE SURE BX IS ON SCREEN
	JL	LINEDONE			;IF NOT, SAVE A LITTLE TIME
	CMP	BX,454
	JG	DOWN
;
	CALL	PRINT2			;PRINT CONNECTING POINT
	JMP	DOWN				;FINISH LINE
;
UP:
	ADD	BX,2
	CMP	BX,CX			;SEE IF DONE
	JE	LINEDONE
;
	CMP	BX,56			;MAKE SURE BX IS ON SCREEN
	JL	UP				;IF NOT, SAVE A LITTLE TIME
	CMP	BX,454
	JG	LINEDONE
;
	CALL	PRINT2			;PRINT CONNECTING POINT
	JMP	UP				;FINISH LINE
;
LINEDONE:
	MOV	BX,CX			;NEXT POINT TO PLOT
	POP	CX				;GET CX BACK
	JMP	LINELOOP
;
PLOTDONE:
	TEST	AL,04			;SEE IF PLOT WAS OFF SCREEN
	JNZ	X1
	JMP	EFG
;				PLOT CURSORS IF THEY ARE ON
X1:	
	MOV	BP,SP		;GET OLD SP BACK
	ADD	BP,6
	MOV	DI,6[BP]		;GET X1
	MOV	BX,WORD PTR ES: [DI]
	CMP	BX,00		;MAKE SURE ITS ON SCREEN
	JGE	X1E
	JMP 	X2
X1E:	CMP	BX,500	
	JLE	X1F
	JMP	X2
;
X1F:	MOV	CX,BX		;CX IS X COORDINATE OF CURSOR
	MOV	SI,16[BP]		;POINTS TO FIRST POINT OF ARRAY
	SAL	BX,1			;MULTIPLY X COORDINATE BY 2
	ADD	SI,BX		;SI POINTS TO Y(X1)
;
	MOV	BX,DX			;GET VOFFSET
	ADD	BX,WORD PTR ES:[SI]	;SHOULD ADD FIRST POINT OF ARRAY
                                      	;VALUE IS BETWEEN 0 AND 255
	TEST	AL,01			;CHECK FOR INVERT
	JZ	PLUSX1
	NEG	BX				;NORMAL
	ADD	BX,256			;BX=256-BX
;
PLUSX1:
; VALUE IN BX IS Y COORDINATE OF CURSOR
	SAL	BX,1
	MOV	DI,8[BP]			;GET HOFFSET
	MOV	BP,WORD PTR ES: [DI]
	ADD	CX,BP			;CX=X COORDINATE + HOFFSET
	PUSH	DX			;DRAW CURSOR 1
	MOV	DX,CX
	ADD	DX,10
	SUB	CX,10
X1HOR:
	CALL	PRINT1
	ADD	CX,2
	CMP	CX,DX
	JLE	X1HOR
;
	SUB	CX,12		;RESTORE CX
	MOV	DX,BX
	ADD	DX,10
	SUB	BX,10
X1VER:
	CALL	PRINT1
	ADD	BX,2
	CMP	BX,DX
	JLE	X1VER
;
	MOV	BX,DX
	SUB	CX,4
	MOV	DX,CX
	ADD	DX,8
X1TOP:
	CALL	PRINT1
	ADD	CX,2
	CMP	CX,DX
	JLE	X1TOP
;
	SUB	BX,20
	SUB	CX,10
X1BOT:
	CALL	PRINT1
	ADD	CX,2
	CMP	CX,DX
	JLE	X1BOT
;
	POP	DX				;RESTORE DX FOR X2
;
X2:	
	MOV	BP,SP		;GET OLD SP BACK
	ADD	BP,6
	MOV	DI,4[BP]		;GET X2
	MOV	BX,WORD PTR ES: [DI]
	CMP	BX,00			;MAKE SURE ITS ON SCREEN
	JGE	X2E
	JMP 	DONE
X2E:	CMP	BX,500	
	JLE	X2F
	JMP	DONE
;
X2F:	MOV	CX,BX
	MOV	SI,16[BP]		;POINTS TO FIRST POINT OF ARRAY
	SAL	BX,1			;MULTIPLY X COORDINATE BY 2
	ADD	SI,BX		;SI POINTS TO Y(X2)
;
	MOV	BX,DX			;GET VOFFSET
	ADD	BX,WORD PTR ES:[SI]	;SHOULD ADD POINT AT CURSOR
                             	;VALUE IS BETWEEN 0 AND 255
	TEST	AL,01			;CHECK FOR INVERT
	JZ	PLUSX2
	NEG	BX				;INVERT
	ADD	BX,256			;AX=256-AX
;
PLUSX2:
; VALUE IN BX IS YCOORDINATE OF CURSOR
	SAL	BX,1
	MOV	DI,8[BP]			;GET HOFFSET
	MOV	BP,WORD PTR ES: [DI]
	ADD	CX,BP			;CX=X COORDINATE + HOFFSET
					;DRAW CURSOR 2
	MOV	DX,CX
	ADD	DX,10
	SUB	CX,10
X2HOR:
	CALL	PRINT1
	ADD	CX,2
	CMP	CX,DX
	JLE	X2HOR
;
	SUB	CX,12		;RESTORE CX
	MOV	DX,BX
	ADD	DX,10
	SUB	BX,10
X2VER:
	CALL	PRINT1
	ADD	BX,2
	CMP	BX,DX
	JLE	X2VER
;
	JMP	DONE
;
EFG:	CMP	BX,56		;IF PLOT WAS ABOVE SCREEN
	JLE	DNARROW		;THEN SHOW DOWN ARROW
UPARROW:
	MOV	BX,452D		;ELSE SHOW UP ARROW
	MOV	CX,125
	CALL PRINT1
	MOV	BX,450
	MOV	CX,123
	CALL PRINT1
	MOV	CX,127
	CALL PRINT1
	MOV	BX,448
	MOV	CX,121
	CALL PRINT1
	MOV	CX,124
	CALL PRINT1
	MOV	CX,126
	CALL PRINT1
	MOV	CX,129
	CALL PRINT1
	MOV	 BX,446
	MOV	CX,124
	CALL PRINT1
	MOV	CX,126
	CALL PRINT1
	MOV	BX,444
	CALL PRINT1
	MOV	CX,124
	CALL PRINT1
	MOV	BX,442 
	CALL PRINT1
	MOV	CX,126
	CALL PRINT1
	JMP	DONE
DNARROW:
	MOV	BX,58
	MOV	CX,125
	CALL PRINT1
	MOV	BX,60 
	MOV	CX,123
	CALL PRINT1
	MOV	CX,127
	CALL PRINT1
	MOV	BX,62
	MOV	CX,121
	CALL PRINT1
	MOV	CX,124
	CALL PRINT1
	MOV	CX,129
	CALL PRINT1
	MOV	CX,126
	CALL PRINT1
	MOV	BX,64
	CALL PRINT1
	MOV	CX,124
	CALL PRINT1
	MOV	BX,68
	CALL PRINT1
	MOV	CX,126
	CALL PRINT1
	MOV	BX,70
	CALL PRINT1
	MOV	CX,124
	CALL PRINT1
;
DONE:
	POP	DS			;GET DS BACK
	POP	ES			;GET ES BACK
	POP	BP
	RET 	14			;FINISHED
START	ENDP
;
;
; PRINT SUBROUTINE
;
;	BX......CONTAINS 2 * Y COORDINATE TO PLOT
;	CX......CONTAINS X COORDINATE TO PLOT
;	DS......POINTS TO START OF VIDEO MEMORY
;	ES......HAS VALUE OF DS WHEN PROGRAM WAS ENTERED
;	CS:MAP..ADDRESS OF ROW MAP
;
;	CHANGED....DI,AH,BP
;
;
; FIRST, CONVERT CX TO A BYTE COUNT AND AN OUTPUT BYTE
;
PRINT	PROC	NEAR
PRINT1:
	MOV	BP,CX			;SAVE CX
	MOV	CX,07H			;GET LAST THREE BITS OF CX
	AND	CX,BP
	MOV	AH,80H			;SET UP OUTPUT BYTE
	SHR	AH,CL			;AH CONTAINS OUTPUT BYTE
;
	MOV	CX,BP			;RESTORE CX
	SHR	BP,1				;DIVIDE CX BY 8 FOR BYTE COUNT
	SHR	BP,1
	SHR	BP,1				;BP CONTAINS BYTE COUNT
;
	CMP	BP,62			;MAKE SURE BP IS ON SCREEN
	JG	QUIT
	OR	BP,BP
	JS	QUIT
;
	CMP	BX,56			;MAKE SURE BX IS ON SCREEN
	JL	QUIT
	CMP	BX,454       
JG	QUIT
;
	OR	AL,04			;POINT IS ON SCREEN..SET FLAG
;
; SECONDARY ENTRY POINT....USES OLD BP AND AH TO PLOT POINT
;					  BP AND AH ARE NOT CHANGED
;
PRINT2:
;
	MOV	DI,BP			;CALCULATE OUTPUT ADDRESS
	ADD	DI,CS:[BX+MAP]		;DI HAS OUTPUT ADDRESS
;
	OR	BYTE PTR [DI],AH	;OR OUTPUT BYTE ONTO SCREEN
;
QUIT:
	RET
;
PRINT	ENDP
PLOT	ENDS
	END